# Generated by the gRPC Python protocol compiler plugin. DO NOT EDIT!
"""Client and server classes corresponding to protobuf-defined services."""
import grpc

from google.protobuf import empty_pb2 as google_dot_protobuf_dot_empty__pb2
import knn_pb2 as knn__pb2


class KNNStub(object):
    """Interface exported by the server.
    """

    def __init__(self, channel):
        """Constructor.

        Args:
            channel: A grpc.Channel.
        """
        self.sendProjectionPoints = channel.stream_unary(
                '/provee.KNN/sendProjectionPoints',
                request_serializer=knn__pb2.TrainingChunk.SerializeToString,
                response_deserializer=google_dot_protobuf_dot_empty__pb2.Empty.FromString,
                )
        self.getKNNRequest = channel.unary_unary(
                '/provee.KNN/getKNNRequest',
                request_serializer=knn__pb2.knnRequest.SerializeToString,
                response_deserializer=knn__pb2.Neighbours.FromString,
                )
        self.getIDfromServer = channel.unary_unary(
                '/provee.KNN/getIDfromServer',
                request_serializer=google_dot_protobuf_dot_empty__pb2.Empty.SerializeToString,
                response_deserializer=knn__pb2.ID.FromString,
                )


class KNNServicer(object):
    """Interface exported by the server.
    """

    def sendProjectionPoints(self, request_iterator, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def getKNNRequest(self, request, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def getIDfromServer(self, request, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')


def add_KNNServicer_to_server(servicer, server):
    rpc_method_handlers = {
            'sendProjectionPoints': grpc.stream_unary_rpc_method_handler(
                    servicer.sendProjectionPoints,
                    request_deserializer=knn__pb2.TrainingChunk.FromString,
                    response_serializer=google_dot_protobuf_dot_empty__pb2.Empty.SerializeToString,
            ),
            'getKNNRequest': grpc.unary_unary_rpc_method_handler(
                    servicer.getKNNRequest,
                    request_deserializer=knn__pb2.knnRequest.FromString,
                    response_serializer=knn__pb2.Neighbours.SerializeToString,
            ),
            'getIDfromServer': grpc.unary_unary_rpc_method_handler(
                    servicer.getIDfromServer,
                    request_deserializer=google_dot_protobuf_dot_empty__pb2.Empty.FromString,
                    response_serializer=knn__pb2.ID.SerializeToString,
            ),
    }
    generic_handler = grpc.method_handlers_generic_handler(
            'provee.KNN', rpc_method_handlers)
    server.add_generic_rpc_handlers((generic_handler,))


 # This class is part of an EXPERIMENTAL API.
class KNN(object):
    """Interface exported by the server.
    """

    @staticmethod
    def sendProjectionPoints(request_iterator,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.stream_unary(request_iterator, target, '/provee.KNN/sendProjectionPoints',
            knn__pb2.TrainingChunk.SerializeToString,
            google_dot_protobuf_dot_empty__pb2.Empty.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def getKNNRequest(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/provee.KNN/getKNNRequest',
            knn__pb2.knnRequest.SerializeToString,
            knn__pb2.Neighbours.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def getIDfromServer(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/provee.KNN/getIDfromServer',
            google_dot_protobuf_dot_empty__pb2.Empty.SerializeToString,
            knn__pb2.ID.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)
